//===========================================================================
// package
//===========================================================================
package jp.gr.java_conf.bugslife.bug;

//===========================================================================
// import
//===========================================================================
// Java core API
import java.util.*;
import java.text.*;
import org.apache.commons.logging.*;

// DB API
import jp.gr.java_conf.bugslife.db.*;

// Util API
import jp.gr.java_conf.bugslife.util.*;
import jp.gr.java_conf.bugslife.user.*;
//import jp.gr.java_conf.bugslife.system.*;


/**
 *<PRE>
 * 
 * Ccクラス
 * 
 *</PRE>
 * @version	0.0, 2001/09/10
 * @author	鰐川　正寛
 */
//===========================================================================
public class Cc implements IUpdatable, ILoadable
{
//===========================================================================
// attributes
//===========================================================================
	/**
	 *	バグ番号
	 */
	private int m_bno = 0;
	/**
	 *	ユーザ番号
	 */
	private int m_uno = 0;
	/**
	 *	ユーザ名（略称）
	 */
	private String m_nickname = null;
	/**
	 *	メールアドレス
	 */
	private String m_email = null;
	/**
	 *	更新者
	 */
	private int m_updateUno = 0;
	/**
	 *	更新日時
	 */
	private Date m_updateDate = new Date();
	/**
	 * Log
	 */
	private Log log = LogFactory.getLog(this.getClass().getName());
//=====================================
// DB用項目定義
//=====================================
	/**
	 * 排他制御
	 */
	private static final boolean EXCLUSION = true;	//あり
	/**
	 * AutoIncrement
	 */
	private static final boolean ATOINCREMENT = false;	//なし
	/**
	 * PK 
	 */
	private static final String[] PK = {"bno", "uno"};
	/**
	 * 更新項目名
	 */
	private static final String[] DB_ITEMS = {
									"bno","uno",
									"updateUno" };
//===========================================================================
// methods
//===========================================================================
	/**
	 *	デフォルトコンストラクタ
	 *
	 */
	public Cc()
	{
		
	}
//======================================
// db access methods
//======================================
	/**
	 *	insertDB
	 *
	 * @return	処理結果
	 */
	public void insert(int updateUno)
	{
		setUpdateUno(updateUno);
		DAO.insert(this);
	}
	/**
	 *	delete
	 *
	 * @return	処理結果
	 */
	public void delete(int updateUno)
	{
		setUpdateUno(updateUno);
		DAO.delete(this);
	}
	/**
	 *	load
	 *
	 * @return	処理結果
	 */
	public void load()
	{
		DAO.load(this);
	}
	/**
	 *	findAll
	 *
	 * @return	処理結果
	 */
	public static Collection findAll()
	{
		return DAO.findAll(new Cc());
	}
	/**
	 *	Ccの取得（バグ番号指定）
	 *
	 * @return	処理結果
	 */
	public static Collection getCc(int bno)
	{
		String sql = 
		"SELECT" +
		" A.bno as bno," +
		" A.uno as uno," +
		" A.updateUno as updateUno," +
		" A.updateDate as updateDate," +
		" B.nickname as nickname," +
		" B.email as email" +
		" FROM Cc AS A" +
		" LEFT JOIN UserInfo AS B ON A.uno = B.uno" +
		" WHERE A.bno = ?" +
		" ORDER BY A.bno,B.nickname";
		
		ArrayList params = new ArrayList();
		params.add(new Integer(bno));
		
		return( DAO.find(new Cc(), sql, params));
	}
	/**
	 *	Ccの生成
	 *
	 * @return	処理結果
	 */
	public static Cc createCc(int bno, int uno)
	{
		Cc cc = new Cc();
		cc.setBno(bno);
		cc.setUno(uno);
		UserInfo user = UserInfo.getUser(uno);
		cc.setNickname(user.getNickname());
		cc.setEmail(user.getEmail());
		
		return cc;
		
	}
//======================================
// Db Interface
//======================================
	/**
	 * 
	 */
	public String[] getUpdateItemNames() {
		
		return DB_ITEMS;
		
	}
	/**
	 * PK items
	 */
	 public String[] getPKItems() {
		return PK;
	}
	/**
	 * 排他制御ありなし
	 */
	public boolean isExclusion() {
		return EXCLUSION;
	}
	/**
	 * AutoIncrementありなし
	 */
	public boolean isAutoIncrement() {
		return ATOINCREMENT;
	}
//======================================
// request param
//======================================
	/**
	 *	request parametorの生成
	 */
	public Map getMapping() {
		HashMap map = new HashMap();
		map.put("uno", new Integer(m_uno));
		return map;
	}
//======================================
// Property
//======================================
	/**
	 * バグ番号の取得
	 * 
	 * @return バグ番号
	 */
	public int getBno()
	{
		return m_bno;
	}
	/**
	 * バグ番号のセット
	 * 
	 * @param bno バグ番号
	 */
	public void setBno(int bno)
	{
		m_bno = bno;
	}
	/**
	 * ユーザ番号の取得
	 * 
	 * @return ユーザ番号
	 */
	public int getUno()
	{
		return m_uno;
	}
	/**
	 * ユーザ番号のセット
	 * 
	 * @param uno ユーザ番号
	 */
	public void setUno(int uno)
	{
		m_uno = uno;
	}
	/**
	 * ユーザ名（略称）の取得
	 * 
	 * @return ユーザ名（略称）
	 */
	public String getNickname()
	{
		return m_nickname;
	}
	/**
	 * ユーザ名（略称）のセット
	 * 
	 * @param nickname ユーザ名（略称）
	 */
	public void setNickname(String nickname)
	{
		m_nickname = nickname;
	}
	/**
	 * メールアドレスの取得
	 * 
	 * @return メールアドレス
	 */
	public String getEmail()
	{
		return m_email;
	}
	/**
	 * メールアドレスのセット
	 * 
	 * @param email メールアドレス
	 */
	public void setEmail(String email)
	{
		m_email = email;
	}
	/**
	 * 更新者の取得
	 * 
	 * @return 更新者
	 */
	public int getUpdateUno()
	{
		return m_updateUno;
	}
	/**
	 * 更新者のセット
	 * 
	 * @param updateUno 更新者
	 */
	public void setUpdateUno(int updateUno)
	{
		m_updateUno = updateUno;
	}
	/**
	 *	更新日の取得
	 *
	 * @return	update		更新日文字列
	 */
	public Date getUpdateDate()
	{
		return m_updateDate;
	}
	/**
	 *	更新日の取得
	 *
	 * @return	update		更新日文字列
	 */
	public String getUpdateDateString()
	{
		return Converter.getDateString(m_updateDate, Converter.DATE_TIME);
	}
	/**
	 *	更新日のセット
	 *
	 * @return	update		更新日文字列
	 */
	public void setUpdateDate(Date date)
	{
		m_updateDate = date;
	}
//===========================================================================
// methods
//===========================================================================
	/**
	 *	クラス情報
	 */
	public String toString()
	{
		StringBuffer sb = new StringBuffer();
		sb.append("--- [Cc] --- \n");
		sb.append("bno       : " + m_bno + "\n");
		sb.append("uno       : " + m_uno + "\n");
		sb.append("nickname  : " + m_nickname + "\n");
		sb.append("email     : " + m_email + "\n");
		sb.append("updateUno : " + m_updateUno + "\n");
		sb.append("updateDate: " + getUpdateDateString() + "\n");
		sb.append("--- [Cc] --- \n");
		return sb.toString();
	}
	/**
	 *	テストメイン
	 */
	public static void main(String[] args)
	{
		System.out.println("------- << Cc Test Start >> -----------");
		unitTest1();	//新規作成テスト
		unitTest2();	//削除テスト
		unitTest3();	//コード指定コンストラクトテスト
		
		System.out.println("------- << Cc Test End >> -----------");
	}
	
	/**
	 *	unitTest1
	 *
	 * 新規作成テスト
	 *
	 */
	public static void unitTest1()
	{
		System.out.println("------- unitTest1 -----------");
		
		//値のセット
		Cc cc = new Cc();
		
		for(int i = 0; i < 10; i++) {
			cc.setBno(2);
			cc.setUno(i+1);
			cc.insert(0);	//追加
		}
		
		//表示
		display(Cc.getCc(2));
		
	}
	/**
	 *	unitTest2
	 *
	 * ユーザ削除テスト
	 *
	 */
	public static void unitTest2()
	{
		System.out.println("------- unitTest2 -----------");
		
		//存在チェック
		Collection ccs = Cc.getCc(2);
		if (ccs == null) {
			//存在していなかったらテスト中止
			throw new Error("target is nothing");
		}
		
		Iterator ite = ccs.iterator();
		while(ite.hasNext()) {
			Cc cc = (Cc)ite.next();
			cc.delete(2);		//削除
		}
		
		//存在チェック
		ccs = Cc.getCc(2);
		if (ccs != null) {
			//存在していなかったらテスト中止
			throw new Error("delete failer");
		}
	}
	/**
	 *	unitTest3
	 *
	 * コード指定検索
	 *
	 */
	public static void unitTest3()
	{
		System.out.println("------- unitTest3 -----------");
		
		display(Cc.getCc(1));
		
	}
	/**
	 * リストの表示
	 *
	 */
	private static void display(Collection list)
	{
		Iterator ite = list.iterator();
		
		while(ite.hasNext()) {
			Cc Cc = (Cc)ite.next();
			
			System.out.println(Cc.toString());
		}
	}
}